% Rui changes some paras
% Calibration example. Adjust the parameters of your lenslet array and use
% your SHWFS reference image.

clear all;
close all;
clc;
%%
addpath('../examples/');
addpath('../data/');
%%
sh_flat=imread('ref_olympus25X_20160423.tif');
sh_flat_bg=imread('ref_olympus25X_20160423_bg.tif');
sh_flat=sh_flat-sh_flat_bg; %subtract background

%% parameters
shstruct = struct();
shstruct.calibration_date = datestr(now, 'yyyymmddHHMMSS');
shstruct.use_bg = 0;               % subtract background from images
shstruct.thresh_binary_img = 0.06;%0.08 % threshold for binary image coarse grid
shstruct.thresh_corr_img = 0.55;  % threshold for correlation image area detect
shstruct.npixsmall = 8; %8           % remove objects less than npixsmall
shstruct.npixsmall_corr = 6;         % remove objects less than npixsmall for corr-image
shstruct.strel_rad = 8;              % strel ratio (image processing in coarse grid)
shstruct.strel_rad_corr = 8;         % strel ratio (image processing in corr-image)
shstruct.coarse_grid_radius = round((500/13)/2)-1;  % radius for coarse grid
shstruct.percent = 0.8;%0.2            % threshold used in centroid fine grid
                                       % this value shoule be bigger when
                                       % more noisy of the image
                                       % scale estimated radius in the fine grid 
% define the size and sigma of gaussian filter used for psf
shstruct.psfsize = 31;
shstruct.psfsigma = 1;
% this caused the fine grid to be smaller than the course grid
shstruct.multiply_est_radius = 0.9; %1/sqrt(2)
shstruct.centroid = @centroid;     % centroid algorithm

%% lenslet documentation
shstruct.totlenses = 170;
shstruct.flength = 25.6e-3;
shstruct.pitch = 500e-6;

%% camera documentation
shstruct.camera_pixsize = 13*1e-6;
shstruct.maxinteger = 2^16 - 1;       % maximum integer value for the image

%% params Dai modal wavefront estimation
shstruct.sa_radius_m = shstruct.pitch/2;
shstruct.dai_n_zernike = 10;%5  % max radial order of the Zernike polynomials

%% replace your reference SHWFS images here
%load sh_flat;    % (almost) diffraction-limited image taken with the SHWFS
%load sh_flat_bg; % dark frame (optional)

%% run the calibration
shwfs_calibrate;
