
function centres = shwfs_get_centres_nodraw(img, shstruct, ...
    myfuncentroid)

nspots = shstruct.nspots;
ordgrid = shstruct.ord_sqgrid;
centres = zeros(nspots, 2);
thresh_fine_img = shstruct.thresh_fine_img;
npixsmall_corr = shstruct.npixsmall_corr;
strel_rad_corr = shstruct.strel_rad_corr;
psf_size = shstruct.psfsize_sample;
psf_sigma = shstruct.psfsigma_sample;

img_corr = corsscorrelation(psf_size,psf_sigma,img);


for ith = 1:nspots
    cc = ordgrid(ith, :);
    subimage = img(cc(3):cc(4), cc(1):cc(2));
    subimage_corr = img_corr(cc(3):cc(4), cc(1):cc(2));
    
    iimax = max(max(subimage_corr));
    iimin = min(min(subimage_corr));
    
    level = (iimax - iimin)*thresh_fine_img; 
    subimage_corr = subimage_corr - iimin;
    subimage_corr_bw = im2bw(subimage_corr, level);
    
    % find the max area (20170224)
    subimage_corr_bw_label = bwlabel(subimage_corr_bw);
    stats = regionprops(subimage_corr_bw);
    area = cat(1,stats.Area);
    index = find(area == max(area));
    subimage_corr_bw = ismember(subimage_corr_bw_label,index);
    
%     %remove small objects
%     subimage_corr_bw = bwareaopen(subimage_corr_bw, npixsmall_corr);
%     % remove edges
%     se = strel('disk',strel_rad_corr);
%     subimage_corr_bw = imclose(subimage_corr_bw, se);
 
    if sum(sum(subimage_corr_bw))==0
        subimage_corr_bw(round(size(subimage_corr_bw,1)/2),...
            round(size(subimage_corr_bw,1)/2)) = 1;
    end
        
    
%     subimage_thr = subimage.*int16(subimage_corr_bw);
    subimage_thr = subimage.*(subimage_corr_bw);
    
    % level = (iimax - iimin)*shstruct.percent + iimin;   
     dd = myfuncentroid(subimage_thr);
     
    % centroid returns in column major order
    centres(ith, :) = [cc(1)+dd(2)-1, cc(3)+dd(1)-1];
    
   
end


end